/******************************************************************************
 * $Id: functions.h,v 1.245 2001/09/05 04:00:45 jimb Exp $
 * Author		: Jim Brooks	<jim@jimbrooks.org>
 * Description	: Function prototypes.
 ******************************************************************************/

/*****************************************************************************
 * main.c
 *****************************************************************************/
void
InitGlobals( void );

void
InitFontNames( void );

void
RestoreVars( void );

void
SaveVars( void );

void
ParseCommandLine( int argc, char* argv[] );

/*****************************************************************************
 * widgets.c
 *****************************************************************************/
void
CreateWidgets( void );

void
CreateMainWindow( void );

void
CreateMenubarToolbar( void );

void
ChangeStyleColorTextSel( GtkWidget* pWidget,
                         GdkColor*  pColorFgText,
                         GdkColor*  pColorBgText,
                         GdkColor*  pColorFgSel,
                         GdkColor*  pColorBgSel );

void
ChangeStyleColorText( GtkWidget* pWidget,
                      GdkColor*  pColorFg,
                      GdkColor*  pColorBg );

void
ChangeStyleColorSel( GtkWidget* pWidget,
                     GdkColor*  pColorFg,
                     GdkColor*  pColorBg );

gboolean
ChangeStyleFont( GtkWidget* pWidget,
                 char*      pFontName );

void
ApplyFontListWidgets( void );

gint
FontHeight( GdkFont* pFont );

void
PositionWidgetAtMiddle( GtkWidget* pWidget );

void
PositionShowDialogAtMiddle( GtkWidget* pWidgetDialog );

void
PositionShowFindDialog( GtkWidget* pWidgetDialog );

void
WidgetWidthHeight( GtkWidget* pWidget,
                   gint*      pWidth,
                   gint*      pHeight );

void
KludgeForWidgetGeom( GtkWidget* pWidget,
                     int x,
                     int y );

void
WidgetGeom( GtkWidget* pWidget,
            gint*      pX,
            gint*      pY,
            gint*      pW,
            gint*      pH );

void
PrependComboDropDown( char*   pString,
                      GList** ppGList );

GtkWidget*
CreateButtonLabelUnderlined( const gchar* pLabelText,
                             const gchar* pLabelPattern );

gboolean
IsAnyMajorFunctionBusy( void );

void
SetSensitivityWhileBusy( gboolean sensitive );

void
SetPanedSlidersInitialPositions( void );

int
PanedSliderPercent( GtkWidget* pWidget );

void
ProcessPendingEvents( void );

void
PeriodicallyProcessPendingEvents( int limit );

/*****************************************************************************
 * handlers.c
 *****************************************************************************/
gboolean
HandlerKeyPressMain( GtkWidget*   pWidget,
                     GdkEventKey* pEvent,
                     gpointer     unused );

gboolean
HandlerKeyPressText( GtkWidget*   pWidget,
                     GdkEventKey* pEvent,
                     gpointer     unused );

gboolean
ComplainAboutEditing( GdkEventKey* pEvent );

gboolean
HandlerKeyPressClist( GtkWidget*   pWidget,
                      GdkEventKey* pEvent,
                      gpointer     unused );

gboolean
HandlerKeyRelease( GtkWidget*   pWidget,
                   GdkEventKey* pEvent,
                   gpointer     unused );

gboolean
HandlerKeyPressDialogFind( GtkWidget*   pWidget,
                           GdkEventKey* pEvent,
                           gpointer     unused );

gboolean
HandlerKeyPressDialogLine( GtkWidget*   pWidget,
                           GdkEventKey* pEvent,
                           gpointer     unused );

gboolean
HandlerActivateComboLine( GtkWidget*   pWidget,
                          GdkEventKey* pEvent,
                          gpointer     unused );

gboolean
HandlerLineNum( GtkWidget*      pWidget,
                GdkEventButton* pEvent,
                gpointer        ununsed );

void
HandlerToolbarButtonEarlierTag( GtkWidget* pWidgetUnused,
                                gpointer   unused );

void
HandlerToolbarButtonLaterTag( GtkWidget* pWidgetUnused,
                              gpointer   unused );

void
HandlerToolbarButtonGotoTag( GtkWidget* pWidgetUnused,
                             gpointer   unused );

void
HandlerToolbarButtonFindMatches( GtkWidget* pWidgetUnused,
                                 gpointer   unused );

void
HandlerToolbarButtonRecordCursor( GtkWidget* pWidgetUnused,
                                  gpointer   unused );

void
HandlerSwitchPageNotebook( GtkNotebook*     pNotebook,
                           GtkNotebookPage* pNotebookPage,
                           gint             page_num,
                           gpointer         unused );

void
HandlerDrawClistKludge( GtkWidget*    pWidget,
                        GdkRectangle* pRect,
                        gpointer      unused );

void
InstallFocusHandlers( GtkWidget* pWidget );

gboolean
HandlerFocusIn( GtkWidget*     pWidget,
                GdkEventFocus* pEvent,
                gpointer       unused );

gboolean
HandlerFocusOut( GtkWidget*     pWidget,
                 GdkEventFocus* pEvent,
                 gpointer       unused );

void
HandlerButtons( GtkWidget* pWidget,
                gpointer   pUnused );

gint
HandlerDeleteEvent( GtkWidget* pWidget,
                    GdkEvent*  pEvent,
                    gpointer   pUnused );

void
WordAtCursorClicked( void );

void
RestoreCursorClicked( void );

gboolean
HandlerFocusbarExpose( GtkWidget*      pWidget,
                       GdkEventExpose* pEvent,
                       gpointer        pFocusbar );

void
HandlerTreeItemSelected( GtkTree*	pWidgetTree,
                         GtkWidget* pWidgetItem,
                         gpointer	unused );

void
HandlerSubtreeSelected( GtkTree*   pWidgetItem,	/* refers to a subtree (node), not a leaf (tree item) */
                        gpointer   unused );

/*****************************************************************************
 * list.c
 *****************************************************************************/
void
CreateTagsClistWidget( void );

void
CreateInvisibleTagsClistWidget( GtkWidget** ppWidgetScrolled,
                                GtkWidget** ppWidgetClist,
                                int         columnsLayout,
                                PFUNC       RowSelectCallback,
                                PFUNC       RowUnselectCallback );

void
CreateModulesClistWidget( void );

void
PopulateTagsClistWidget( int sort );

void
PopulateModulesClistWidget( void );

void
TagsClistWidgetRowSelectCallback( GtkWidget*      pWidget,
                                  gint            row,
                                  gint            col,
                                  GdkEventButton* pEvent,
                                  gpointer	      pData );

void
ModulesClistWidgetRowSelectCallback( GtkWidget*      pWidget,
                                     gint            row,
                                     gint            col,
                                     GdkEventButton* pEvent,
                                     gpointer        pData );

void
TagsClistWidgetRowUnselectCallback( GtkWidget*      pWidget,
                                    gint            row,
                                    gint            col,
                                    GdkEventButton* pEvent,
                                    gpointer	    pData );

void
ModulesClistWidgetRowUnselectCallback( GtkWidget*      pWidget,
                                       gint            row,
                                       gint            col,
                                       GdkEventButton* pEvent,
                                       gpointer	       pData );

void
SelectClistRow( GtkWidget* pWidgetClist,
                gint       row );

void
SelectClistRowAsThoughUserDid( GtkWidget* pWidgetClist,
                               gint       row );

void
UnselectClistRow( GtkWidget* pWidgetClist,
                  gint*      pSelectedRow );

void
AddSortedModuleGlist( gpointer pModuleName,
                      gpointer pUnused,
                      gpointer ppGlist );

void
AddRowToAnyTagsClistWidget( GtkWidget* pWidgetClist,
                            gpointer   pData,
                            gpointer   pUnused,
                            gboolean   prependOrAppend );

void
AddRowToTagsClistWidget( gpointer pData,
                         gpointer pUnused );

void
AddRowToModulesClistWidget( gpointer pModuleName,
                            gpointer pUnused );

gint
SearchClistWidget( gchar*     pSought,
                   gchar*     pModuleName,
                   GtkWidget* pWidgetClist,
                   int        selectedRow,
                   int        exact,
                   int        caseSens,
                   int        quiet,
                   gboolean   selectNotebookPage,
                   gboolean   doSelectRow );

int
ClistColumnWidth( GtkWidget* pWidgetClist,
                  int        col );

/*****************************************************************************
 * history.c
 *****************************************************************************/
void
CreateHistoryClistWidget( void );

void
HistoryClistWidgetRowSelectCallback( GtkWidget*      pWidget,
                                     gint            row,
                                     gint            col,
                                     GdkEventButton* pEvent,
                                     gpointer	     pData );

void
HistoryClistWidgetRowUnselectCallback( GtkWidget*      pWidget,
                                       gint            row,
                                       gint            col,
                                       GdkEventButton* pEvent,
                                       gpointer        pData );

void
PrependTagHistory( struct TAG* pTag );

void
UndoPrependTagHistory( void );

void
StepHistoryList( gboolean stepDown );

void
RecordCursorInTagHistory( char* pTagName );

void
UndoRecordCursorInTagHistory( void );

/*****************************************************************************
 * treefunc.c
 *****************************************************************************/

#include "treefunc.h"

/*****************************************************************************
 * text.c
 *****************************************************************************/
void
CreateTextWidgetEtAl( GtkWidget**  ppWidgetText,	/*OUT*/
                      GtkWidget**  ppWidgetVbox,	/*OUT*/
                      GtkWidget**  ppWidgetTable,	/*OUT*/
                      GtkWidget**  ppWidgetVscroll,	/*OUT*/
                      GtkWidget**  ppWidgetHscroll,	/*OUT*/
                      focusbar_t** ppFocusbar		/*OUT*/ );

void
ConnectHandlersForTextWidget( GtkWidget* pWidget );

void
ApplyTabWidth( GtkWidget* pWidget,
               int        width );

FUNC_X
LoadTextWidgetWithModule( gchar*   pModule,
                          gint	   cursor,
                          gint     row,
                          gboolean reload );

void
LoadTextWidgetWithBuffer( gpointer pBuffer,
                          gint     bufferSize,
                          int      srcFileKind );

void
ClearTextWidget( void );

void
RedrawBothTextWidgets( void );

void
RedrawActiveTextWidget( void );

int
IsTextWidgetEmpty( void );

int
LineAtCursor( void );

void
ScrollTextWidgetToLine( int   line,
                        float vertFrac );

void
RecenterTextWidget( void );

void
RecordLocationAsPrevious( void );

void
GotoPrev( void );

void
GotoLine( void );

gboolean
HighlightLine( int line );

void
HighlightWordInCurrentLine( const char* pWord );

void
HighlightTextString( gchar* pText,
                     gint   idx,
                     gint   len );

void
HighlightTag( struct TAG* pTag,
              guint       idxCursor );

void
HighlightChar( int line,
               int idxText );

int
PrintLineNum( void );

gint
IdleLineNum( gpointer dontCare );

guint
TextCursorIdx( void );

gboolean
IsCursorOverWord( void );

GString*
ScoopWordAtCursor( int   maxWordLen,
                   char* pText,
                   int   textLen,
                   int   idxCursor );

void
SaveCursor( CURSOR* pCursor );

void
RestoreCursor( CURSOR* pCursor );

char*
ActiveTextWidgetContents( guint* sizeOut );

void
SetActiveTextWidget( GtkWidget* pWidget );

void
RecordActiveModuleName( char* pModuleName );

char*
ActiveModuleName( void );

void
RecordActiveModuleHashItem( P_HASH_ITEM_MODULE pHashItem );

P_HASH_ITEM_MODULE
ActiveModuleHashItem( void );

/*****************************************************************************
 * hilite.c
 *****************************************************************************/
void
HiliteLoadCode( GtkWidget* pWidget,
                char*      pBuffer,
                int        bufferSize,
                int        srcFileKind );

void
HiliteStringOfCode( GtkWidget*   pWidget,
                    GdkFont*	 pFontKeyword,
                    GdkFont*	 pFontType,
                    GdkFont*	 pFontSymbol,
                    GdkColor*	 pColorKeyword,
                    GdkColor*	 pColorType,
                    GdkColor*	 pColorSymbol,
                    const char*  pStr,
                    int          strSize,
                    char*		 pScratch,
                    int          srcFileKind );

const char*
HiliteParseInsertComment( GtkWidget*  pWidget,
                          GdkColor*   pColor,
                          GdkFont*    pFont,
                          const char* pCommentStartApprox,
                          const char* pCommentEndDef,
                          int         bufferSize );

FUNC_X
HiliteQuotedString( GtkWidget*   pWidget,
                    GdkColor*    pColor,
                    GdkFont*     pFont,
                    const char*  pStart,
                    const char*  pDquote1,
                    const char*  pBufEnd,
                    const char** ppAfter /*OUT*/ );

int
FindWord( const char* pWords,
          char*       pSought );

/*****************************************************************************
 * notebook.c
 *****************************************************************************/
void
CreateNotebook( void );

int
NotebookPageTags( void );

int
NotebookPageModules( void );

int
NotebookPageHistory( void );

int
NotebookPageFunctions( void );

int
NotebookPageFound( void );

/*****************************************************************************
 * prefs.c
 *****************************************************************************/
void
EditPrefs( void );

GtkWidget*
CreatePropertyPageFont( void );

GtkWidget*
CreatePropertyPageLayout( void );

GtkWidget*
CreatePropertyPageNumbers( void );

GtkWidget*
CreatePropertyPageMisc( void );

GtkWidget*
CreatePropertyPageKeyboard( void );

void
HandlerPropertyPageFontButton( GtkWidget* pWidget,
                               gpointer   pStr );

void
HandlerFontSelOk( GtkWidget*              pWidget,
                  GtkFontSelectionDialog* pWidgetFsd );

void
HandlerFontSelCancel( GtkWidget*              pWidget,
                      GtkFontSelectionDialog* pWidgetFsd );

void
HandlerPropertyPageEntryModified( GtkWidget* pWidget,
                                 gpointer   pUnused );

void
HandlerPropertyPageToggle( GtkWidget* pWidget,
                           gpointer   pUnused );

void
HandlerPropertyPageApply( GtkWidget* pWidget,
                          gint       page,
                          gpointer   pUnused );

gint
HandlerPropertyPageClose( GnomeDialog* pGnomeDialog,
                          gpointer     pUnused );

void
SaveFontNames( void );

void
RestoreFontNames( void );

void
ApplyFonts( void );

/*****************************************************************************
 * find.c
 *****************************************************************************/
void
FindMatchesUnderCursor( void );

gchar*
FindStringInSegment( gchar* pSought,
                     gchar* pSegment,
                     int    segmentLen );

gboolean
FindNextStringInTextWidget( void );

int
FindTagCheckMultipleMatches( char*    pTagName,
                             char*    pModuleName,
                             int      rowStarting,
                             gboolean exact,
                             gboolean caseSens,
                             gboolean selectNotebookPage,
                             char*    pMsgMultipleMatches );

void
FindNextTextOrTag( void );

gint
FindNextTag( void );

gboolean
FindStringInTextWidget( gchar*   pSought,
                        gboolean tryWrap,
                        gboolean quiet,
                        gboolean scroll,
                        gint*    pReturnLineNumFound );

gboolean
FindStringInTextWidget_( gchar*   pSought,
                         gboolean tryWrap,
                         gboolean quiet,
                         gboolean scroll,
                         gint*    pReturnLineNumFound,
                         gchar*   pText,
                         gint     textLen );

gboolean
FindStringGlobal( gchar*   pSought,
                  gboolean quiet,
                  gboolean stopIfFindDialogClosed );

gboolean
BuildListOfFoundStrings( gchar*   pSought,
                         gboolean quiet,
                         gboolean stopIfFindDialogClosed );

FUNC_X
AppendFoundTagsList( gchar* pTagName,
                     gchar* pModuleName,
                     gint   lineNum );

void
BuildNotebookPageWithFindResults( void );

void
AddRowToFoundClistWidget( gpointer pData,
                          gpointer pUnused );

void
FoundClistWidgetRowSelectCallback( GtkWidget*      pWidget,
                                   gint            row,
                                   gint            col,
                                   GdkEventButton* pEvent,
                                   gpointer	       pData );

void
FoundClistWidgetRowUnselectCallback( GtkWidget*      pWidget,
                                     gint            row,
                                     gint            col,
                                     GdkEventButton* pEvent,
                                     gpointer	     pData );

/*****************************************************************************
 * popup.c
 *****************************************************************************/
void
Popup( char*    pMsg,
       char*    pTitle,
       int      whichFont );

void
PopupClose( GtkWidget* pWidget,
            gpointer   pData );

void
PopupClosing( GtkWidget* pWidget,
              gpointer   pData );

/*****************************************************************************
 * statusbar.c
 *****************************************************************************/
void
RecordStatusbarMsg( gchar* pMsg );

gchar*
GetStatusbarMsg( void );

void
PrintStatusbarNoTimeout( gchar* pMsg );

void
PrintStatusbar( gchar* pMsg );

void
PrintStatusbarThirdsNoTimeout( gchar* pMsg1,
                               gchar* pMsg2,
                               gchar* pMsg3 );
void
PrintStatusbarThirds( gchar* pMsg1,
                      gchar* pMsg2,
                      gchar* pMsg3 );

void
PrintStatusbarForRow( gchar* pMsg,
                      gint   row );

gint
RowAssociatedWithStatusbar( void );

void
SetStatusbarInitialMsg( gchar* pMsg );

void
ClearStatusbar( void );

void
MostlyClearStatusbar( void );

void
EnableStatusbarTimeout( void );

gint
StatusbarTimedOut( gpointer unused );

void
StatusbarShowPercentage( char* pMsg,
                         int   percent );

/*****************************************************************************
 * focusbar.c
 *****************************************************************************/
focusbar_t*
FocusbarCreate( char* pFontName );

void
FocusbarDestroy( focusbar_t* pFocusbar );

void
FocusbarLabelSet( focusbar_t* pFocusbar,
                  char*       pStr );

void
FocusbarFocusGain( focusbar_t* pFocusbar );

void
FocusbarFocusLose( focusbar_t* pFocusbar );

void
FocusbarPaint( focusbar_t* pFocusbar );

/*****************************************************************************
 * tags.c
 *****************************************************************************/
void
PrepareProcessCtags( void );

void
ProcessCtagsFromFile( char* pFilename );

void
ProcessCtagsFromStdin( void );

GList*
ProcessCtagsBuf( char* pCtags,
                 long  ctagsSize );

void
WarnTooManyTags( void );

void
ResortTagsGlist( int sort );

gint
ResortTagsGlistCompare( gconstpointer pTag1,
                        gconstpointer pTag2 );

inline gint
CompareTags( const PTAG pTag1,
             const PTAG pTag2,
             int        member );

FUNC_X
AddCtagsLineToTagsGlist( const char*  pLine,
                         GList**      ppGlist,         /*OUT*/
                         GList**      ppGlistLastLink, /*IN/OUT*/
                         struct TAG** ppTag            /*OUT*/ );

void
MinimizeTagStruct( struct TAG* pTag,
                   GList*      pGlist );

struct TAG*
AllocTagStruct( void );

void
FreeTagStruct( struct TAG* pTag );

void
FillTagStruct( struct TAG* pTag,
               gchar*      pName,
               gint        lineNum,
               gchar*      pType,
               gchar*      pModule );

char*
ReadCtagsFromFile( long* pCtagsSize, /* out */
                   char* pFilename );

const char*
CheckTagType( const char* pTagType );

void
GotoTagUnderCursor( void );

int
IsTagChar( gchar c );

PTAG
FindTag( char* pTagName,
         char* pTagType );

PTAG
FindFuncTag( char*    pFuncName,
             char*    pModuleName );

PTAG
FindFuncTagInOneModule( char*              pFuncName,
                        P_HASH_ITEM_MODULE pHashItem );

/*****************************************************************************
 * menu.c
 *****************************************************************************/
void
CreateMenubar( GtkWidget* pWidgetHbox );

void
MenuItemSelected( gpointer   pData,
                  guint      menuItem,
                  GtkWidget* pWidget );

void
MenuItemFindTag( void );

void
CreateFindDialog( MENU_ITEM menuItem );

void
FindDialogClose( void );

void
FindDialogClickedFind( void );

void
CheckButtonFindToggledBool( GtkWidget* pWidget,
                            gpointer   pVarBool );

void
CheckButtonFindGlobalToggled( GtkWidget* pWidget,
                              gpointer   pData );

void
CheckButtonFindReverseToggled( GtkWidget* pWidget,
                               gpointer   pData );

/*****************************************************************************
 * toolbar.c
 *****************************************************************************/
void
CreateToolbar( GtkWidget* pWidgetHbox );

/*****************************************************************************
 * module.c
 *****************************************************************************/
gpointer
ModuleBuffer( gchar* pModuleName,
              long*  pModuleSize /* out */ );

void
FreeModuleBuffer( gchar* pModuleName );

guint
HashModuleKey( gconstpointer pKey );

gint
HashModuleCmp( gconstpointer  pName1,
               gconstpointer  pName2 );

void
CreateModuleNameGlist( void );

void
AddSortedModuleGlist( gpointer pModuleName,
                      gpointer pUnused,
                      gpointer ppGlist );

/*****************************************************************************
 * file.c
 *****************************************************************************/
gpointer
LoadFile( gchar* pFname,
          long*  pFsize /* out */ );

GString*
LoadFileSpecial( gchar* pFileName );

long
FileSize( gchar* pFilename );

int
WhichKindOfSrcFile( char* pFilename );

int
IsCSrcFile( char* pFilename );

int
IsAsmSrcFile( char* pFilename );

int
IsPerlSrcFile( char* pFilename );

int
IsForthSrcFile( char* pFilename );

FUNC_X
FilterMsdosCr( char*  pBufOld,
               int    sizeOld,
               char** ppBufNew, /*OUT*/
               int*   pSizeNew  /*OUT*/ );

/*****************************************************************************
 * utils.c
 *****************************************************************************/

/* --- inline --- */

extern inline int
IsWhitespace( char c );

extern inline int
IsCSymbolChar( char c );

extern inline const char*
FindCSymbolChar( const char* pStr,
                 int         len );

extern inline int
IsEolUnix( const char* pc );

extern inline int
IsEolMsdos( const char* pc );

extern inline int
IsEol( const char* pc );

extern inline int
IsLineEmpty( const char* pLine );

extern inline void
CopyChars( char*       pDest,
           const char* pSrc,
           int         amount );

extern inline const char*
PastWord( const char* pWord,
          int         size );

extern inline const char*
PastWhitespace( const char* pc,
                int         max );

extern inline char*
CreateString( int size );

extern inline char*
CloneString( const char* src );

extern inline void
DeleteString( char* p );

extern inline int
CompareStrings( const char* s1,			/* -- Don't replace this with strcmp()!!! -- */
                const char* s2 );

extern inline int
CompareStringsNonCase( const char* s1,	/* -- Don't replace this with strcmp()!!! -- */
                       const char* s2 );

/* -------------- */

FUNC_X
ParseWord( const char*  pc,
           const char** ppWord,
           int          max );

FUNC_X
ParseWordAlphanum( const char*  pc,
                   const char** ppWord,
                   int          max );

const char*
NextLine( const char* pc,
          int         max );

const char*
ToLine( const char*	pc,
        int		line,
        int		maxLineSize );

char*
ToEol( const char* pLine,
       int         max );

gint
LineIdx2LineNum( gchar* pText,
                 gint   idx );

const char*
PastEol( const char* pc );

int
IsWordChar( gchar c );

char*
ExtractLine( const char* pLine,
             int         maxLineLen );

GString*
CreateGString( char* pInit,
               int   len );

#ifdef HYPERSRC_SPEED
#define StrLen strlen
#else
size_t
StrLen( const char* pStr );
#endif

#ifdef HYPERSRC_SPEED
#define FindSubstr strstr
#else
char*
FindSubstr( const char* pHaystack,
            const char* pNeedle );
#endif

char*
FindSubstrI( const char* pHaystack,
             const char* pNeedle );

char*
FindSubstrSegment( const char* pHaystack,
                   int         haystackLen,
                   const char* pNeedle,
                   gboolean    caseSens );

char*
FindSubstrReverse( const char* pHaystackTop,
                   const char* pHaystackBottom,
                   const char* pNeedle,
                   P_FUNC_STRCMPX pFuncCmp );

void
FreeGlistDynamic( GList* pGlist );

void
FreeGlistDynamicFreeElem( gpointer pData,
                          gpointer pUnused );

gint
HashStrcmp( gconstpointer pKey1,
            gconstpointer pKey2 );

GList*
fast_g_list_append( GList*   list,
                    gpointer data,
                    GList**  last /* IN/OUT */ );

void
ExtractDirFromPathname( const char* pPathname,
                        char**      ppDirBegin, /*OUT*/
                        char**      ppDirEnd    /*OUT*/ );

int
ExtractPathFromPathname( char* pPathname );

char*
ExtractFilenameFromPathname( char* pPathname );

#include "utils.h"

/*****************************************************************************
 * sort.c
 *****************************************************************************/

/* --- inline --- */

extern inline void
GlistInsert( GList* pLinkPreceding,
             GList* pLinkToInsert );

extern inline void
GlistPrepend( GList* pGlist,
              GList* pLinkToPrepend );

extern inline void
GlistRemoveNonFirstLink( GList* pGlist,
                         GList* pLinkToRemove );

/* -------------- */

GList*
InsertionSortGlist( GList* pGlist );

#include "sort.h"

/*****************************************************************************
 * sys_*.c
 *****************************************************************************/
void
SysInstallSignalHandlers( void );

/*****************************************************************************
 * debug.c
 *****************************************************************************/
#ifdef HYPERSRC_DEBUG
void
PrintUsecElapsed( GTimeVal* pTimeval1,
                  GTimeVal* pTimeval2 );
#endif
