/******************************************************************************
 * $Id: globals.h,v 1.136 2001/02/27 03:40:52 jimb Exp $
 * Author		: Jim Brooks	<jim@jimbrooks.org>
 * Description	: Global data.
 ******************************************************************************/

#ifdef HYPERSRC_DEFINE_GLOBALS
#define GLOBAL
#define INIT(x) = x
#else
#define GLOBAL		extern
#define INIT(x) 
#endif

/*
 * Pointers to widgets.
 */
GLOBAL GtkWidget*      pWidgetMain;
GLOBAL GtkWidget*      pWidgetVboxMain;
GLOBAL GtkWidget*      pWidgetToolbar;
GLOBAL GtkWidget*      pWidgetToolbarButtonGotoLine;
GLOBAL GtkWidget*      pWidgetToolbarButtonGotoTag;
GLOBAL GtkWidget*      pWidgetToolbarButtonLaterTag;
GLOBAL GtkWidget*      pWidgetToolbarButtonEarlierTag;
GLOBAL GtkWidget*      pWidgetToolbarButtonFindMatches;
GLOBAL GtkWidget*      pWidgetToolbarButtonRecordCursor;
GLOBAL GtkWidget*      pWidgetNotebook;
GLOBAL GtkWidget*      pWidgetNotebookFuncTree;
GLOBAL GtkWidget*      pWidgetNotebookScrolledFuncTree;
GLOBAL GtkWidget*      pWidgetFuncTree;
GLOBAL GtkWidget*      pWidgetFrameFuncTree;
GLOBAL GtkWidget*      pWidgetClistTags;
GLOBAL GtkWidget*      pWidgetClistFound;
GLOBAL GtkWidget*      pWidgetClistModules;
GLOBAL GtkWidget*      pWidgetClistHistory;
GLOBAL GtkWidget*      pWidgetScrolledTags;
GLOBAL GtkWidget*      pWidgetScrolledFound;
GLOBAL GtkWidget*      pWidgetScrolledModules;
GLOBAL GtkWidget*      pWidgetScrolledHistory;
GLOBAL GtkWidget*      pWidgetScrolledFuncTree;
GLOBAL GtkWidget*      pWidgetTextMain;
GLOBAL GtkWidget*      pWidgetTextAux;
GLOBAL GtkWidget*      pWidgetTextActive;		/* points to either main/aux text widgets */

GLOBAL GtkWidget*      pWidgetVboxTextMain;
GLOBAL GtkWidget*      pWidgetTableTextMain;
GLOBAL GtkWidget*      pWidgetHscrollTextMain;
GLOBAL GtkWidget*      pWidgetVscrollTextMain;

GLOBAL GtkWidget*      pWidgetVboxTextAux;
GLOBAL GtkWidget*      pWidgetTableTextAux;
GLOBAL GtkWidget*      pWidgetHscrollTextAux;
GLOBAL GtkWidget*      pWidgetVscrollTextAux;

GLOBAL GtkWidget*      pWidgetPaned;
GLOBAL GtkWidget*      pWidgetPanedFuncTree;
GLOBAL GtkWidget*      pWidgetPanedText;
GLOBAL GtkWidget*      pWidgetStatusbar;
GLOBAL GtkWidget*      pWidgetDialogFind;
GLOBAL GtkWidget*      pWidgetDialogLine;
GLOBAL GtkWidget*      pWidgetComboFind;
GLOBAL GtkWidget*      pWidgetComboLine;
GLOBAL GtkWidget*      pWidgetCheckButtonFindExact;
GLOBAL GtkWidget*      pWidgetCheckButtonFindCase;
GLOBAL GtkWidget*      pWidgetCheckButtonFindGlobal;
GLOBAL GtkWidget*      pWidgetCheckButtonFindReverse;
GLOBAL GtkWidget*      pWidgetCheckButtonFunctree;
GLOBAL GtkWidget*      pWidgetFontSel;
GLOBAL GtkWidget*      pWidgetWithFocus;
GLOBAL GtkAccelGroup*  pAccelGroup;
GLOBAL GtkItemFactory* pItemFactory;

/*
 * Text widget state.
 */
GLOBAL CURSOR cursorText;

/*
 * Focusbars.
 */
GLOBAL focusbar_t* pFocusbarTextMain;
GLOBAL focusbar_t* pFocusbarTextAux;
GLOBAL focusbar_t* pFocusbarTextActive;

/*
 * Tag and tag clist widget state.
 */
GLOBAL GList*	pGlistTags;								/* pointer to a glist of TAG structs */
GLOBAL GList*	pGlistFuncTags;							/* pointer to a glist of TAG structs of functions only */
GLOBAL int		ctagsLines;								/* inc'd by ProcessCtagsBuf() */
GLOBAL int      tagsCnt;								/* same as g_list_length( pGlistTags ) */
GLOBAL GList*	pGlistFoundTags;						/* list of tagged lines resulting from Find/Global */
GLOBAL int		widgetTagsClistWidthCol[WIDGET_TAGS_CLIST_COLUMNS];
GLOBAL int		widgetFoundClistWidthCol[WIDGET_FOUND_CLIST_COLUMNS];
GLOBAL gint		widgetTagsClistSelectedRow INIT(ROW_NONE);
GLOBAL int		tagSortInitial INIT(SORT_UNSORTED);		/* how tags are initially sorted */
GLOBAL int		tagsSorted;								/* amount of sorted tags */
GLOBAL int		tagsSortedPercentShown;					/* {0,5,10,..95} percentage being shown by statusbar */
GLOBAL int		textLeft INIT(FALSE);
GLOBAL int		textLeftApplied;
GLOBAL int		tagsColumnsLayout INIT(TAG_COL_LAYOUT_TAG_MODULE_TYPE_LINE);
GLOBAL int		tagsLineColumn INIT(3);

/*
 * Modules clist widget state.
 */
GLOBAL int		widgetModulesClistWidthCol[WIDGET_MODULES_CLIST_COLUMNS];
GLOBAL gint		widgetModulesClistSelectedRow INIT(ROW_NONE);
GLOBAL int      returnEarlyModuleSelectCallback INIT(FALSE);

/*
 * History clist widget state.
 */
GLOBAL int		widgetHistoryClistWidthCol[WIDGET_HISTORY_CLIST_COLUMNS];
GLOBAL gint		widgetHistoryClistSelectedRow INIT(ROW_NONE);
GLOBAL gboolean prependingTagHistory INIT(FALSE);
GLOBAL gboolean activeHistoryRowSelect INIT(FALSE);
GLOBAL GSList*  pGslistHistoryCursor;					/* records cursor positions */

/*
 * State for all clists.
 */
GLOBAL gboolean rowSelectedByProgram INIT(0);

/*
 * Notebook state.
 */
GLOBAL gint	    notebookPageWithSelectedRow;
GLOBAL gboolean notebookPageFound INIT(FALSE);
GLOBAL gboolean kludgeNotebookSwitchPage INIT(FALSE);

/*
 * Paned widget state.
 */
GLOBAL gint	    panedSliderPercent			INIT(0);	/* ## set by config, thereafter, is stale ##  */
GLOBAL gint	    panedSliderFuncTreePercent	INIT(0);	/* ## set by config, thereafter, is stale ##  */
GLOBAL gint	    panedSliderTextPercent		INIT(0);	/* ## set by config, thereafter, is stale ##  */

/*
 * Statusbar state.
 */
GLOBAL guint	statusbarContextId;
GLOBAL guint	statusbarMsgs INIT(0);
GLOBAL gint		statusbarRow INIT(ROW_NONE);
GLOBAL gchar*	pStatusbarInitMsg;
GLOBAL GString* pGStringStatusbarMsg;			/* access this using Get[Record]StatusbarMsg() */
GLOBAL gint     timerStatusbar INIT(0);

/*
 * Misc. widget state.
 */
GLOBAL gboolean widgetsReady INIT(FALSE);
GLOBAL gint		widgetMainGeom[4];			/* x/y/w/h of main window */
GLOBAL gchar    mainWindowTitle[256];
GLOBAL gboolean kludgeWidgetGeomUseGetPosition INIT(TRUE);
GLOBAL gboolean auxKeyPressed INIT(FALSE);	/* if pressed, tagged line will be shown in aux. text widget */
GLOBAL int		auxKeyGdkKeyval INIT(GDK_Shift_L);
GLOBAL int		auxKeyGdkMask   INIT(GDK_SHIFT_MASK);

/*
 * Find state.
 */
MENU_ITEM	soughtType;				/* either a tag or a text string */
GString*	pSoughtTag;
GString*	pSoughtText;
GString*	pSoughtModule;
gboolean	findCaseSensText   INIT(FALSE);		/* for string searches */
gboolean	findCaseSensTag    INIT(FALSE);		/* for tag    searches */
gboolean	findCaseSensModule INIT(FALSE);		/* for module searches */
gboolean	findExactTag	 INIT(FALSE);		/* for tag    searches */
gboolean	findExactModule  INIT(FALSE);		/* for module searches */
gboolean    findGlobal INIT(FALSE);				/* for string searches */
gboolean	findReverse;						/* for string searches */
gint        findGeom[4];
GList**		ppGlistFindStrings;		/* ptr to pGlistFindStrings[Tag,Text,Module] */
GList*		pGlistFindStringsTag;
GList*		pGlistFindStringsText;
GList*		pGlistFindStringsModule;

/*
 * Goto line widget state.
 */
GList*		pGlistLineStrings;

/*
 * Dialog widget state.
 */
GLOBAL gboolean buttonWordAtCursorFlag INIT(FALSE);
GLOBAL gboolean buttonRestoreCursorFlag INIT(FALSE);
GLOBAL gboolean dialogPlacement INIT(DIALOG_PLACEMENT_TOP_CORNER);

/*
 * Variables assigned via the command line (or GNOME config).
 */
GLOBAL gint     tabWidth INIT(0);
GLOBAL gboolean hilite INIT(TRUE);
GLOBAL gboolean skipFuncTree INIT(FALSE);	/* can't be changed if tree was built!!! */
GLOBAL gboolean skipFuncTree_pref;			/* pref code should affect this instead */

/*
 * Colors of the clist widgets.
 */
GLOBAL GdkColor colorClistWidgetTextFg
#ifdef HYPERSRC_DEFINE_GLOBALS
= { 0,
    COLOR_CLIST_WIDGET_TEXT_FG_RED,
    COLOR_CLIST_WIDGET_TEXT_FG_GREEN,
    COLOR_CLIST_WIDGET_TEXT_FG_BLUE };
#else
;
#endif

GLOBAL GdkColor colorClistWidgetTextBg
#ifdef HYPERSRC_DEFINE_GLOBALS
= { 0,
    COLOR_CLIST_WIDGET_TEXT_BG_RED,
    COLOR_CLIST_WIDGET_TEXT_BG_GREEN,
    COLOR_CLIST_WIDGET_TEXT_BG_BLUE };
#else
;
#endif

GLOBAL GdkColor colorClistWidgetSelFg
#ifdef HYPERSRC_DEFINE_GLOBALS
= { 0,
    COLOR_CLIST_WIDGET_SEL_FG_RED,
    COLOR_CLIST_WIDGET_SEL_FG_GREEN,
    COLOR_CLIST_WIDGET_SEL_FG_BLUE };
#else
;
#endif

GLOBAL GdkColor colorClistWidgetSelBg
#ifdef HYPERSRC_DEFINE_GLOBALS
= { 0,
    COLOR_CLIST_WIDGET_SEL_BG_RED,
    COLOR_CLIST_WIDGET_SEL_BG_GREEN,
    COLOR_CLIST_WIDGET_SEL_BG_BLUE };
#else
;
#endif

/*
 * Colors of the text widget.
 */
GLOBAL GdkColor colorTextWidgetTextFg
#ifdef HYPERSRC_DEFINE_GLOBALS
= { 0,
    COLOR_TEXT_WIDGET_TEXT_FG_RED,
    COLOR_TEXT_WIDGET_TEXT_FG_GREEN,
    COLOR_TEXT_WIDGET_TEXT_FG_BLUE };
#else
;
#endif

GLOBAL GdkColor colorTextWidgetTextBg
#ifdef HYPERSRC_DEFINE_GLOBALS
= { 0,
    COLOR_TEXT_WIDGET_TEXT_BG_RED,
    COLOR_TEXT_WIDGET_TEXT_BG_GREEN,
    COLOR_TEXT_WIDGET_TEXT_BG_BLUE };
#else
;
#endif

GLOBAL GdkColor colorTextWidgetSelFg
#ifdef HYPERSRC_DEFINE_GLOBALS
= { 0,
    COLOR_TEXT_WIDGET_SEL_FG_RED,
    COLOR_TEXT_WIDGET_SEL_FG_GREEN,
    COLOR_TEXT_WIDGET_SEL_FG_BLUE };
#else
;
#endif
GLOBAL GdkColor colorTextWidgetSelBg
#ifdef HYPERSRC_DEFINE_GLOBALS
= { 0,
    COLOR_TEXT_WIDGET_SEL_BG_RED,
    COLOR_TEXT_WIDGET_SEL_BG_GREEN,
    COLOR_TEXT_WIDGET_SEL_BG_BLUE };
#else
;
#endif

/*
 * Hash table for modules.
 * For speed, a hash table, not a list, is used because module names are recorded
 * (in addition to other info) while processing all the ctags lines.
 */
GLOBAL GHashTable* pHashModules;

/*
 * Hash item of module recently loaded from a file
 * (NOT NECESSARILY THE ONE SHOWN IN TEXT WIDGET!!!)
 * Note when a module is freed, this will still point to its hash item (it won't be nullified).
 */
GLOBAL P_HASH_ITEM_MODULE pHashItemModule;

/*
 * Sorted list of module names (derived from pHashModules).
 * Used to build the modules clist widget (in notebook).
 */
GLOBAL GList* pGlistModuleNames;	/* created when tag clist is populated */

/*
 * If true then previous text buffers are discarded,
 * which saves memory at expense of more file I/O.
 */
GLOBAL gboolean discardTextBuffers INIT(TRUE);

/*
 * Name of file which holds tags.
 */
GLOBAL char*	pTagsFilename;

/*
 * Maximum amount of tags that can be processed (affected by --max-tags arg).
 */
GLOBAL int	maxTags INIT(MAX_TAGS_DEFAULT);
GLOBAL gboolean tooManyTags INIT(FALSE);

/*
 * Flags.
 */
GLOBAL int	hideLineColumn INIT(FALSE);
GLOBAL int	conserveMemory INIT(TRUE);
GLOBAL int	enableProcessPendingEvents INIT(TRUE);

/*
 * Tag sort levels.
 */
GLOBAL int	sort1;
GLOBAL int	sort2;
GLOBAL int	sort3;

/*
 * Font names.
 */
GLOBAL char	fontNameText[MAX_FONT_NAME_LEN];
GLOBAL char	fontNameList[MAX_FONT_NAME_LEN];
GLOBAL char	fontNameHiliteComment[MAX_FONT_NAME_LEN];
GLOBAL char	fontNameHiliteKeyword[MAX_FONT_NAME_LEN];
GLOBAL char	fontNameHiliteType[MAX_FONT_NAME_LEN];
GLOBAL char	fontNameHiliteSymbol[MAX_FONT_NAME_LEN];
/* -- copies -- */
GLOBAL char	fontNameTextCopy[MAX_FONT_NAME_LEN];
GLOBAL char	fontNameListCopy[MAX_FONT_NAME_LEN];
GLOBAL char	fontNameHiliteCommentCopy[MAX_FONT_NAME_LEN];
GLOBAL char	fontNameHiliteKeywordCopy[MAX_FONT_NAME_LEN];
GLOBAL char	fontNameHiliteTypeCopy[MAX_FONT_NAME_LEN];
GLOBAL char	fontNameHiliteSymbolCopy[MAX_FONT_NAME_LEN];

/*
 * Busy state of major outer-level functions.
 * Interrupting a major function to run another one
 * might confuse GTK+ and this program itself.
 * This concern is a caveat of using ProcessPendingEvents()
 * which could otherwise lead to nesting of events.
 */
gboolean	busy_FindStringGlobal			INIT(FALSE);
gboolean	busy_FindDialogClickedFind		INIT(FALSE);
gboolean	busy_PopulateTagsClistWidget	INIT(FALSE);
gboolean	busy_GotoTagUnderCursor			INIT(FALSE);
gboolean	busy_FindMatchesUnderCursor		INIT(FALSE);
gboolean	busy_SearchClistWidget_tag		INIT(FALSE);
gboolean	busy_SearchClistWidget_module	INIT(FALSE);
gboolean	busy_StepHistoryList			INIT(FALSE);	/* -- don't forget to update IsAnyMajorFunctionBusy() -- */

/*
 * Misc.
 */
GLOBAL gboolean ctagsStdin INIT(FALSE);
GLOBAL char		cCommentStartChars[3];
GLOBAL char		cCommentEndChars[3];
GLOBAL gboolean funcTreeVerbose INIT(TRUE);
GLOBAL gboolean disableFuncTreeUpdates INIT(FALSE);		/* corresponds to a check button */
GLOBAL gboolean acceptAllTags INIT(FALSE);
GLOBAL gboolean printStatusMsgs INIT(FALSE);			/* non-debug status messages using printf() */

/*
 * Vars for debugging/profiling.
 */
#ifdef HYPERSRC_DEBUG
GTimeVal timeval1;
GTimeVal timeval2;
#endif
