/*****************************************************************************
 * $Id: parser.h,v 1.9 2001/03/04 07:06:44 jimb Exp $
 * Author		: Jim Brooks	<jim@jimbrooks.org>
 * Description	: 
 *****************************************************************************/

#if 0
#define DEBUG
#endif

#define LEX_YACC_QUIET

#ifdef DEBUG

#ifndef DebugMsg
#define DebugMsg( format, args...) \
{\
   printf(format , ## args);\
   printf( "\n" );\
}
#endif

#else /* !DEBUG */

#ifndef DebugMsg
#define DebugMsg( format, args...)
#endif

#endif /* DEBUG */

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

enum
{
   PARSER_MODE_HYPERSRC,	/* for hypersrc */
   PARSER_MODE_PRINTF		/* output via printf() */
};

/*
 * yacc (public)
 */
void
ParseFuncsInModule( char* pInput, long inputSize, char* pInputName, int debug );

/*
 * yacc (internal)
 */
#ifdef PARSER_Y

static void
ParserCreate( int mode, int strHeapSize );

static void
ParserDelete( void );

static void
ParserReset( int howMuchToReset );

static void
ParserErrorRecover( void );

#endif /* PARSER_Y */

/*
 * lex (public)
 */
void*
LexBufferUse( char* buf );

void
LexBufferDiscard( void* hnd );

/*
 * lex (internal)
 */
#ifdef PARSER_L

static int
LexToken( char* pLexeme, int token );

static void
LexReset( void );

static void
LexErrorRecover( void );

#endif /* PARSER_L */
