/******************************************************************************
 * $Id: sys_unix.c,v 1.3 2001/02/22 03:18:16 jimb Exp $
 * Author		: Jim Brooks	<jim@jimbrooks.org>
 * Description	: Generic UNIX functions to support hypersrc.
 ******************************************************************************/

#include "header.h"

#include <unistd.h>
#include <signal.h>

/*****************************************************************************
 * Segfault handler.
 *****************************************************************************/
static void
sig_segv( int signo )
{
   static int cnt = 0;

   if ( cnt++ == 0 )
   {
      printf( "\n" );
      printf( "*** Dooohhh!!! \n" );
      printf( "*** hypersrc caught a SIGSEGV. \n" );
      if ( ActiveModuleHashItem()  &&  ActiveModuleHashItem()->pModuleName )
      {
         printf( "*** module being browsed was: %s \n", ActiveModuleHashItem()->pModuleName );
      }
      printf( "\n" );
   }

   gtk_exit( 1 );
}

/*****************************************************************************
 * Called by hypersrc to install (non-GTK+) system-specific signal handlers.
 *****************************************************************************/
void
SysInstallSignalHandlers( void )
{
   signal( SIGSEGV, sig_segv );
}
