/******************************************************************************
 * $Id: treefunc.h,v 1.17 2001/02/14 04:26:46 jimb Exp $
 * Author		: Jim Brooks	<jim@jimbrooks.org>
 * Description	: Function prototypes.
 ******************************************************************************/

#ifndef TREEFUNC_H
#define TREEFUNC_H

void
BuildFuncGraph( void );

void
AddFuncCallToGraph( char* pFuncCallId,
                    int   line );

void
AddFuncDefToGraph( char* pFuncDefId,
                   int   lineLeftBrace,
                   int   lineRightBrace );

/* ------------------------------------------------ */
#ifndef PARSER_Y

void
RefreshFuncTree( void );

void
UpdateFuncTree( int      line,
                gboolean force );

void
UpdateFuncTreeWidget( funcDef_t* pFuncDef );

void
CreateFuncTreeAncillaryWidgets( void );

gboolean
IgnoreFuncName( char* pFuncName );

gboolean
FilterDuplicateFuncCalls( GSList*     pFuncCallList,
                          funcCall_t* pFuncCall );

funcDef_t*
SearchFuncDefList( int line );

void
CreateNotebookFuncTree( void );

void
NotebookFuncTreeForEachModule( char*              pModulePathname,
                               P_HASH_ITEM_MODULE pHashItem );

void
FreeHashSubtreeItem( gpointer key,
                     gpointer value,
                     gpointer unused );

GtkWidget*
DescendTreeNodesOnModulePath( char* pModulePathname );

GtkWidget*
CreateSubtree( GtkWidget* pWidgetItem,
               gboolean   connectSignals,
               PTAG       pTag,
               char*      pModule );

GtkWidget*
CreateTreeItem( GtkWidget* pWidgetParentTree,
                char*      pItemName,
                PTAG       pTag );

gint
IdleCallback_HyperjumpViaTreeNodeOrItem( gpointer pTag );

void
HyperjumpViaTreeNodeOrItem( PTAG pTag );

gint
IdleCallback_HyperjumpToModuleViaNotebookSubtree( gpointer pModule );

void
HyperjumpToModuleViaNotebookSubtree( char* pModule );

void
DumpFuncGraph( void );

void
CallbackDumpFuncGraph( gpointer key,
                       gpointer val,
                       gpointer unused );

#endif /* PARSER_Y */
/* ------------------------------------------------ */

#endif /* TREEFUNC_H */
